#ifndef TRPCLAT_GENERAL_WRAPPER_HEADER_H
#define TRPCLAT_GENERAL_WRAPPER_HEADER_H
#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "dpc_trpc_lat/executable.h"
#include "TRPCLat_PubDataWrapper.h"
#include "TRPCLat_SubDataWrapper.h"

using namespace jac::ap::trpclatservice::skeleton;
using namespace jac::ap::dmservice::proxy;
using namespace jac::ap::vedservice::proxy;
using namespace jac::ap::canservice::proxy;

GENERATE_PUB_WRAPPER(TRPCLat2CAN_Provide, TRPCLat2CAN_PubDataWrapper, TRPCLatServiceSkeleton, SWC2CAN, TRPCLat2CANEvent);
GENERATE_SUB_WRAPPER(VED2TRPCLat_Required, VED2TRPCLat_SubDataWrapper, VEDServiceProxy , dpc::VED4DPC, VED4DPCEvent, "11", 10);
GENERATE_SUB_WRAPPER(DM2TRPCLat_Required, DM2TRPCLat_SubDataWrapper, DMServiceProxy,dpc::Decision4Lat, Decision4LatEvent, "40", 10);
GENERATE_SUB_WRAPPER(CAN2Lat_Required, CAN2Lat_SubDataWrapper, CANServiceProxy,CAN2SWC, CAN2SWCEvent, "3", 10);


class GeneralWrapper {
public:
    TRPCLat2CAN_Provide _TRPCLat2CAN_Provide;
    VED2TRPCLat_Required _VED2TRPCLat_Required;
    DM2TRPCLat_Required _DM2TRPCLat_Required;
    CAN2Lat_Required _CAN2Lat_Required;

    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
    void Start();
};

#endif
